﻿<?xml version="1.0" encoding="UTF-8"?>
<ContentPage xmlns="http://xamarin.com/schemas/2014/forms"
             xmlns:x="http://schemas.microsoft.com/winfx/2009/xaml"
             x:Class="MyShop.Views.LoginView"
             xmlns:local="clr-namespace:MyShop.CustumControl"
             xmlns:convertors="clr-namespace:MyShop.Convertors"
             xmlns:behaviors="clr-namespace:MyShop.Behaviors"
             xmlns:viewModelBase="clr-namespace:MyShop.ViewModels.Base"
             viewModelBase:ViewModelLocator.AutoWireViewModel="true"
             >
    <ContentPage.Resources>
        <convertors:ReverseBoolean x:Key="reverseBooleanConverter"/>
        <convertors:FirstValidationErrorConverter x:Key="FirstValidationErrorConverter" />
    </ContentPage.Resources>
    <ContentPage.Content>
        <Grid>
            <Grid.RowDefinitions>
                <RowDefinition Height="0.3*"/>
                <RowDefinition Height="*"/>
                <RowDefinition Height="*"/>
                <RowDefinition Height="*"/>
            </Grid.RowDefinitions>
            <local:GradientView Grid.Row="0" Grid.RowSpan="4"
                                StartColor="#D775FF" EndColor="#FFBC75"
                                StartColorOpacity="0.5" EndColorOpacity="0.9"
                                VerticalOptions="FillAndExpand" HorizontalOptions="FillAndExpand"
                                />
            <Frame CornerRadius="10"
                   VerticalOptions="Center"
                   HasShadow="True"
                   IsClippedToBounds="True"
                   Grid.Row="1" Grid.RowSpan="3" 
                   Margin="50"
                   Padding="15">
                <StackLayout VerticalOptions="Fill" HorizontalOptions="Fill" >
                    <Entry Text="{Binding Email.Value, Mode=TwoWay}" Placeholder="E-mail"
                           HorizontalOptions="Fill" HeightRequest="50" >
                        <Entry.Style>
                            <OnPlatform x:TypeArguments="Style">
                                <On Platform="iOS, Android" Value="{StaticResource EntryStyle}" />
                            </OnPlatform>
                        </Entry.Style>
                        <Entry.Behaviors>
						    <behaviors:EventToCommandBehavior
							    EventName="Unfocused"
							    Command="{Binding ValidateEmailCommand}" />
					    </Entry.Behaviors>
					    <Entry.Triggers>
						    <DataTrigger 
							    TargetType="Entry"
							    Binding="{Binding Email.IsValid}"
							    Value="False">
							    <Setter Property="behaviors:LineColorBehavior.LineColor" Value="{StaticResource ErrorColor}" />
						    </DataTrigger>
					    </Entry.Triggers>
                    </Entry>

				    <Label 
					    Text="{Binding Email.Errors, Converter={StaticResource FirstValidationErrorConverter}}"
					    Style="{StaticResource ValidationErrorLabelStyle}" />

                    <Entry Text="{Binding Password.Value, Mode=TwoWay}" Placeholder="Password" HorizontalOptions="Fill" IsPassword="True" HeightRequest="50">
                        <Entry.Style>
                            <OnPlatform x:TypeArguments="Style">
                                <On Platform="iOS, Android" Value="{StaticResource EntryStyle}" />
                            </OnPlatform>
                        </Entry.Style>
					    <Entry.Behaviors>
						    <behaviors:EventToCommandBehavior
							    EventName="Unfocused"
							    Command="{Binding ValidatePasswordCommand}" />
					    </Entry.Behaviors>
					    <Entry.Triggers>
						    <DataTrigger 
							    TargetType="Entry"
							    Binding="{Binding Password.IsValid}"
							    Value="False">
							    <Setter Property="behaviors:LineColorBehavior.LineColor" Value="{StaticResource ErrorColor}" />
						    </DataTrigger>
					    </Entry.Triggers>
                    </Entry>
                    <Label 
					    Text="{Binding Password.Errors, Converter={StaticResource FirstValidationErrorConverter}}"
					    Style="{StaticResource ValidationErrorLabelStyle}" />

                    <Entry IsVisible="{Binding IsShowLogin, Converter={StaticResource reverseBooleanConverter}}"
                           Text="{Binding CurrentUser.Password}" Placeholder="Confirm Password" HorizontalOptions="Fill" IsPassword="True" HeightRequest="50"/>

                    <Button IsVisible="{Binding IsShowLogin}"
                            Text="LOGIN"
                            HorizontalOptions="Fill" CornerRadius="20" BackgroundColor="Purple" TextColor="White" Margin="20"
                            Command="{Binding LogIn}"/>

                    <Label HorizontalOptions="CenterAndExpand"
					    Text="{Binding ErrorLoginMessage}"
					    Style="{StaticResource ValidationErrorLabelStyle}" />

                    <Button IsVisible="{Binding IsShowLogin, Converter={StaticResource reverseBooleanConverter}}"
                            Text="SIGNUP"
                            HorizontalOptions="Fill" CornerRadius="20" BackgroundColor="Purple" TextColor="White" Margin="20"
                            Command="{Binding SignUp}"/>

                    <Label HorizontalOptions="Center" Text="{Binding LoginOrSignUpLabelText}" TextColor="Purple">
                        <Label.GestureRecognizers>
                            <TapGestureRecognizer NumberOfTapsRequired="1" Command="{Binding IsLoginOrSignUp}" />
                        </Label.GestureRecognizers>
                    </Label>
                 </StackLayout>
            </Frame>

            <Frame CornerRadius="20"
                   VerticalOptions="EndAndExpand"
                   HasShadow="True"
                   IsClippedToBounds="True"
                   Grid.Row="0"
                   Grid.RowSpan="2"
                   Margin="30"
                   BackgroundColor="#b82d16"
                   x:Name="appTitle"
                   Padding="10">
                <Label Text="MyShop" TextColor="White" FontSize="60" HorizontalTextAlignment="Center" FontAttributes="Bold" />
            </Frame>
        </Grid>
    </ContentPage.Content>
</ContentPage>
